28.2. /proc

The /proc directory is actually a pseudo-filesystem. The files in the /proc directory mirror currently running system and kernel processes and contain information and statistics about them.

 bash$ cat /proc/devices
 Character devices:
   1 mem
   2 pty
   3 ttyp
   4 ttyS
   5 cua
   7 vcs
  10 misc
  14 sound
  29 fb
  36 netlink
 128 ptm
 136 pts
 162 raw
 254 pcmcia

 Block devices:
   1 ramdisk
   2 fd
   3 ide0
   9 md
 
 
 
 bash$ cat /proc/interrupts
            CPU0       
   0:      84505          XT-PIC  timer
   1:       3375          XT-PIC  keyboard
   2:          0          XT-PIC  cascade
   5:          1          XT-PIC  soundblaster
   8:          1          XT-PIC  rtc
  12:       4231          XT-PIC  PS/2 Mouse
  14:     109373          XT-PIC  ide0
 NMI:          0 
 ERR:          0
 
 
 
 bash$ cat /proc/partitions
 major minor  #blocks  name     rio rmerge rsect ruse wio wmerge wsect wuse running use aveq

    3     0    3007872 hda 4472 22260 114520 94240 3551 18703 50384 549710 0 111550 644030
    3     1      52416 hda1 27 395 844 960 4 2 14 180 0 800 1140
    3     2          1 hda2 0 0 0 0 0 0 0 0 0 0 0
    3     4     165280 hda4 10 0 20 210 0 0 0 0 0 210 210
    ...
 
 
 
 bash$ cat /proc/loadavg
 0.13 0.42 0.27 2/44 1119
          

Shell scripts may extract data from certain of the files in /proc. [1]

 bash$ cat /proc/filesystems | grep iso9660
         iso9660
 
 	      

   1 kernel_version=$( awk '{ print $3 }' /proc/version )

   1 CPU=$( awk '/model name/ {print $4}' < /proc/cpuinfo )
   2 
   3 if [ $CPU = Pentium ]
   4 then
   5   run_some_commands
   6   ...
   7 else
   8   run_different_commands
   9   ...
  10 fi

The /proc directory contains subdirectories with unusual numerical names. Every one of these names maps to the process ID of a currently running process. Within each of these subdirectories, there are a number of files that hold useful information about the corresponding process. The stat and status files keep running statistics on the process, the cmdline file holds the command-line arguments the process was invoked with, and the exe file is a symbolic link to the complete path name of the invoking process. There are a few more such files, but these seem to be the most interesting from a scripting standpoint.


Example 28-1. Finding the process associated with a PID

   1 #!/bin/bash
   2 # pid-identifier.sh: Gives complete path name to process associated with pid.
   3 
   4 ARGNO=1  # Number of arguments the script expects.
   5 E_WRONGARGS=65
   6 E_BADPID=66
   7 E_NOSUCHPROCESS=67
   8 E_NOPERMISSION=68
   9 PROCFILE=exe
  10 
  11 if [ $# -ne $ARGNO ]
  12 then
  13   echo "Usage: `basename $0` PID-number" >&2  # Error message >stderr.
  14   exit $E_WRONGARGS
  15 fi  
  16 
  17 pidno=$( ps ax | grep $1 | awk '{ print $1 }' | grep $1 )
  18 # Checks for pid in "ps" listing, field #1.
  19 # Then makes sure it is the actual process, not the process invoked by this script.
  20 # The last "grep $1" filters out this possibility.
  21 if [ -z "$pidno" ]  # If, after all the filtering, the result is a zero-length string,
  22 then                # no running process corresponds to the pid given.
  23   echo "No such process running."
  24   exit $E_NOSUCHPROCESS
  25 fi  
  26 
  27 # Alternatively:
  28 #   if ! ps $1 > /dev/null 2>&1
  29 #   then                # no running process corresponds to the pid given.
  30 #     echo "No such process running."
  31 #     exit $E_NOSUCHPROCESS
  32 #    fi
  33 
  34 # To simplify the entire process, use "pidof".
  35 
  36 
  37 if [ ! -r "/proc/$1/$PROCFILE" ]  # Check for read permission.
  38 then
  39   echo "Process $1 running, but..."
  40   echo "Can't get read permission on /proc/$1/$PROCFILE."
  41   exit $E_NOPERMISSION  # Ordinary user can't access some files in /proc.
  42 fi  
  43 
  44 # The last two tests may be replaced by:
  45 #    if ! kill -0 $1 > /dev/null 2>&1 # '0' is not a signal, but
  46                                       # this will test whether it is possible
  47                                       # to send a signal to the process.
  48 #    then echo "PID doesn't exist or you're not its owner" >&2
  49 #    exit $E_BADPID
  50 #    fi
  51 
  52 
  53 
  54 exe_file=$( ls -l /proc/$1 | grep "exe" | awk '{ print $11 }' )
  55 # Or       exe_file=$( ls -l /proc/$1/exe | awk '{print $11}' )
  56 #
  57 # /proc/pid-number/exe is a symbolic link
  58 # to the complete path name of the invoking process.
  59 
  60 if [ -e "$exe_file" ]  # If /proc/pid-number/exe exists...
  61 then                 # the corresponding process exists.
  62   echo "Process #$1 invoked by $exe_file."
  63 else
  64   echo "No such process running."
  65 fi  
  66 
  67 
  68 # This elaborate script can *almost* be replaced by
  69 # ps ax | grep $1 | awk '{ print $5 }'
  70 # However, this will not work...
  71 # because the fifth field of 'ps' is argv[0] of the process,
  72 # not the executable file path.
  73 #
  74 # However, either of the following would work.
  75 #       find /proc/$1/exe -printf '%l\n'
  76 #       lsof -aFn -p $1 -d txt | sed -ne 's/^n//p'
  77 
  78 # Additional commentary by Stephane Chazelas.
  79 
  80 exit 0


Example 28-2. On-line connect status

   1 #!/bin/bash
   2 
   3 PROCNAME=pppd        # ppp daemon
   4 PROCFILENAME=status  # Where to look.
   5 NOTCONNECTED=65
   6 INTERVAL=2           # Update every 2 seconds.
   7 
   8 pidno=$( ps ax | grep -v "ps ax" | grep -v grep | grep $PROCNAME | awk '{ print $1 }' )
   9 # Finding the process number of 'pppd', the 'ppp daemon'.
  10 # Have to filter out the process lines generated by the search itself.
  11 #
  12 #  However, as Oleg Philon points out,
  13 #+ this could have been considerably simplified by using "pidof".
  14 #  pidno=$( pidof $PROCNAME )
  15 #
  16 #  Moral of the story:
  17 #+ When a command sequence gets too complex, look for a shortcut.
  18 
  19 
  20 if [ -z "$pidno" ]   # If no pid, then process is not running.
  21 then
  22   echo "Not connected."
  23   exit $NOTCONNECTED
  24 else
  25   echo "Connected."; echo
  26 fi
  27 
  28 while [ true ]       # Endless loop, script can be improved here.
  29 do
  30 
  31   if [ ! -e "/proc/$pidno/$PROCFILENAME" ]
  32   # While process running, then "status" file exists.
  33   then
  34     echo "Disconnected."
  35     exit $NOTCONNECTED
  36   fi
  37 
  38 netstat -s | grep "packets received"  # Get some connect statistics.
  39 netstat -s | grep "packets delivered"
  40 
  41 
  42   sleep $INTERVAL
  43   echo; echo
  44 
  45 done
  46 
  47 exit 0
  48 
  49 # As it stands, this script must be terminated with a Control-C.
  50 
  51 #    Exercises:
  52 #    ---------
  53 #    Improve the script so it exits on a "q" keystroke.
  54 #    Make the script more user-friendly in other ways.

Warning

In general, it is dangerous to write to the files in /proc, as this can corrupt the filesystem or crash the machine.

Notes

[1]

Certain system commands, such as procinfo, free, vmstat, lsdev, and uptime do this as well.